/*
 *  ngtk/c/ngtk_input.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    b1t WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>

void ngtk_init_ncurses_key(void)		/* FIXME */
{
    int i;
    char *ti_strs[11] = { "kcuu1", "kcud1", "kcub1", "kcuf1", "kpp", "knp", \
                          "khome", "kend", "kbs", "kich1", "kdch1" };

    char *ti_fstrs[12] = { "kf1", "kf2", "kf3", "kf4", "kf5", "kf6", "kf7", \
                           "kf8", "kf9", "kf10", "kf11", "kf12" };

    for (i=0;i<=7;i++) {
        keysyms[i].keysym = 0x101 + i;
        keysyms[i].esc_seq = tigetstr(ti_strs[i]);
    }

    keysyms[8].keysym = 0x110;
    keysyms[8].esc_seq = tigetstr("kbs");

    for (i=9;i<=10;i++) {
        keysyms[i].keysym = 0x101 + i + 7;
        keysyms[i].esc_seq = tigetstr(ti_strs[i]);
    }

    for (i=11;i<=22;i++) {
        keysyms[i].keysym = 0x201 + (i-11);
        keysyms[i].esc_seq = tigetstr(ti_fstrs[i-11]);
    }
    last_keysym = 22;
}

int ngtk_define_keysym_ncurses(char *esc_seq, int keysym)
{
    int ks = last_keysym + 1;

    if ((keysyms[ks].keysym == 0) && (keysyms[ks].esc_seq == NULL)) {
        keysyms[ks].keysym = keysym;
        keysyms[ks].esc_seq = esc_seq;
    } else
        return(-1);

    last_keysym++;
    return(ks);
}

size_t ngtk_tty_input(char *buf, size_t length)
{
    size_t bytes;
    bytes = read(0, buf, length);

    return(bytes);
}

void ngtk_tty_read(void)
{
    int keyindex;

    memset(keybuf, 0, 1024);
    for (keyindex = 0; (ngtk_tty_input(keybuf, 1024)) < 0;);
}

int ngtk_parse_buffer(void)
{
    int i;

    for (i=0;i<=last_keysym; i++) {
        if (!strcmp(keybuf, keysyms[i].esc_seq))
            return(keysyms[i].keysym);
    }
    return(0xFFFF);
}

int ngtk_tty_getc_ncurses(void)
{
    ngtk_tty_read();

    if (!strlen(keybuf))
        return(0);

    if (strlen(keybuf) == 1)
        return(keybuf[0]);

    return(ngtk_parse_buffer());
}

int ngtk_tty_getc_slang(void)
{
#ifdef HAVE_SLANG
    int ch;

    while (0 == SLang_input_pending(1000))
        continue;
    ch = SLang_getkey();

    if (ch == 033) {
        if (0 == SLang_input_pending(0))
            return(033);
    }
    SLang_ungetkey(ch);
    return(SLkp_getkey());
#else
    return(0);
#endif
}
